質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.71%

【WordPress】python の requests が、PHP で exec() できない

受付中

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 108

Dakoit

score 11

前提・実現したいこと

Xサーバーの「X10」という共用サーバーでWordPressを使っています。
PHPを経由してpythonの「requests」を使いたいです。

ソースコード

下記のように「header.php」から「test.py」を読んでいます。

「header.php」

<div class="python">
<?php
$py_url = get_template_directory() . '/py/test.py';
$fullPath = '/usr/bin/python3.6 '.$py_url.' 2>&1';
if(!exec($fullPath, $output)){
    echo '読み込み失敗';
}else{
    echo '成功';
    foreach ($output as $o) {
      echo $o;
    }
}
?>
</div>


「test.py」

#!/usr/bin/python3.6
# -*- coding: utf-8 -*-

import requests

発生している問題・エラーメッセージ

しかしXサーバーに「requests」のモジュールが用意されていないようで、「header.php」の出力結果は次のエラーとなります。

<div class="python">
成功Traceback (most recent call last):
File "/home/aaa/aaa.xsrv.jp/public_html/wp-content/themes/my-theme-name/py/test.py", line 4, in
<module>
import requestsModuleNotFoundError: No module named 'requests'
</module>
</div>

試したこと 1/2:「requests」をアップロード

調べましたところ、「XserverでPython3環境を構築してパッケージを自由にインストールする」という方法が最適そうな印象でした。

しかしハードルが高かったため、「test.py」のディレクトリに「requests」をアップロードすればできるのではないかと考えて試しました。

「requests」には、「urllib3」「chardet」「certifi」「idna」の4つも必要なので下記の構成となります。(各バージョンは質問の最後に補足として掲載しています。)

wp-content
├ themes
  └ my-theme-name
    ├ header.php
    ├ py
      ├ test.py
      ├ requests     
      ├ urllib3
      ├ chardet
      ├ certifi
      └ idna


しかしさらなる問題が生じまして、バージョンの不整合エラーが次の通り表示されました。
「urllib3」の1.25か、「chardet」の4.0.0が不整合との内容です。

<div class="python">
成功/home/aaa/aaa.xsrv.jp/public_html/wp-content/themes/my-theme-name/py/requests/__init__.py:91:
RequestsDependencyWarning: urllib3 (1.25) or chardet (4.0.0) doesn't match a supported version!  RequestsDependencyWarning)
</div>

試したこと 2/2:バージョンの確認

そこで整合するバージョンを確認すべく「requests」の「_init_.py」を見てみますと、以下の記述を見つけました。

# urllib3 >= 1.21.1, <= 1.25
# chardet >= 3.0.2, < 3.1.0

上記したバージョンの不整合エラーによれば「urllib3」の1.25は整合しますが、「chardet」の4.0.0が整合しない様子です。

しかしgithubを確認したところ、「chardet」の最新は3.0.4でしたし、わたしもここからダウンロードしたものをアップロードしたはずです。4.0.0なんて使っていないのです。

ここで手詰まりとなりました。なぜバージョンの不整合エラーになるのか分からない状況です。

長々と素人の試したことなどを読ませてしまい誠に恐縮ですが、ここから先、何をすれば進むことができるでしょうか。

アドバイス頂けましたら幸甚に存じます。

補足

「py」ディレクトリにアップロードした各モジュールは以下githubからダウンロードしたものになります。
「urllib3」だけ1.25を使用し、他は最新です。

「requests」
https://github.com/psf/requests
「urllib3」
https://github.com/urllib3/urllib3/releases/tag/1.25
「chardet」
https://github.com/chardet/chardet
「certifi」
https://github.com/certifi/python-certifi
「idna」
https://github.com/kjd/idna

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • dameo

    2020/01/10 23:24

    XSERVERは使ったことがありませんので、回答はできません。以下の手順だけご紹介致します。

    phpファイルのあるディレクトリで
    python3 -m venv 環境名
    で、このディレクトリにvenvによるpythonの仮想環境を作れます。
    source 環境名/bin/activate
    とすると、仮想環境に入り、プロンプトが変わります。
    pip install requests
    とすると、仮想環境にrequestsパッケージが入ります。
    この状態で
    python test.py
    とすれば、requestsのimportに成功するはずです。
    一旦成功したら、仮想環境から
    deactivate
    で抜けます(プロンプトも戻ります)。

    次にpython実行時に仮想環境で実行するように、phpを書き換えます。
    /usr/bin/python3.6 → 現在ディレクトリフルパス/環境名/bin/python
    にしてください。

    動けばラッキー程度の情報です。ご参考までに。

    キャンセル

  • Dakoit

    2020/01/11 20:09

    >phpファイルのあるディレクトリ
    そのディレクトリですが、おそらくVPSでないとアクセスできないのかもしれません。
    ですがVPSの際の手続きとして覚えておきたいと思います。ありがとうございました。

    キャンセル

  • dameo

    2020/01/11 21:45

    header.phpのことなので、VPSでもレンタルサーバでも出来ると思いますが、実際にやるのでやれば内容を理解してからやった方がいいです。参考情報なので、お気になさらず。

    キャンセル

回答 1

0

sshで接続して、
pip install request
で出来ないですか?

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.71%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る